#include"global.c"
#include"my_os.c"

#include <stdbool.h>
#include<avr/io.h>


register bool akku;
register float realakku;
register int intakku;


//Structures for functions

typedef struct{
bool CLK,m,Q;
	      }R_TRIG,F_TRIG;

 typedef struct {
	bool IN,Q;
	R_TRIG_rttimer;
	int ET,PT;
		}TP;

typedef struct {
	bool IN,Q;
	TP tp_on; 
	int ET,PT;
	F_TRIG ft1,ft2;
		}TON;

 typedef struct {
		bool IN,Q;
		TP tp_of;
		int ET,PT;
		F_TRIG ft1;
		}TOF;

  typedef struct {
		R_TRIG rt_up;
		bool CU,RESET,Q;
		int PV,CV;
		}CTU;

 typedef struct {
		R_TRIG rt_down;
		bool CD,LOAD,Q;
		int CV,PV;
		}CTD;

  typedef struct {
		R_TRIG rt_1,rt_2;
		bool CU,CD,LOAD,RESET,QU,QD;
		int CV,PV;
		}CTUD;             

ISR(SIG_OVERFLOW1)
{
//disable interrupt
  cli();

//save registers using Y pointer
  asm("ST      -Y,R27");
  asm("ST      -Y,R26");
  asm("ST      -Y,R25");
  asm("ST      -Y,R24");
  asm("ST      -Y,R31");
  asm("ST      -Y,R30");
  asm("ST      -Y,R3");
  asm("ST      -Y,R2");
  asm("ST      -Y,R1");
  asm("ST      -Y,R0");
  asm("ST      -Y,R23");
  asm("ST      -Y,R22");
  asm("ST      -Y,R21");
  asm("ST      -Y,R20");
  asm("ST      -Y,R19");
  asm("ST      -Y,R18");
  asm("ST      -Y,R17");
  asm("ST      -Y,R16");
  asm("IN      R26,0x3F");
  asm("IN      R27,0x3B");
  asm("  ST -Y, R4");
  asm("  ST -Y, R5");
  asm("  ST -Y, R6");
  asm("  ST -Y, R7");
  asm("  ST -Y, R8");
  asm("  ST -Y, R9");
  asm("  ST -Y, R10");
  asm("  ST -Y, R11");
  asm("  ST -Y, R12");
  asm("  ST -Y, R13");
  asm("  ST -Y, R14");
  asm("  ST -Y, R15");
  asm("  ST -Y, R26");

  global_inc++;//increment interrupt counter variable for time expire task switching
  global_inc_g++;//increment time counter for delay function


//test time expire
  if(b_start_so)//only if start OS
   {
   if(global_inc>=(task_time*TICK_TIME))//if time period for current task expire
   {
//init interrupt counter variable
    global_inc=0;
//init t_sp and t_r variables
    t_sph=0;
    t_spl=0;
    t_r29=0;
    t_r28=0;
    get_tsp();//

//save Y pointer for current task
    asm("  LDS R30,t_r28");//R26 <- t_r28
    asm("  LDS R31,t_r29");//R27 <- t_r29
    asm("  ST -Z, R28");//salvare pointer Y
    asm("  ST -Z, R29");

//save stack pointer for current task
    asm("  LDS R30,t_spl");//stack pointer is saved using Y pointer already saved
    asm("  LDS R31,t_sph");
    asm("  IN R16,0x3d");//save SPH
    asm("  ST -Z,R16");
    asm("  IN R16,0x3e");//save SPL
    asm("  ST -Z,R16");


    push_var();//save global variables
    comuta_task();//task switching
    pop_var();//restore global variables for new current task

//restore stack pointer for new current task
  asm("  LDS R28,t_spl");
  asm("  LDS R29,t_sph");
  asm("  LD R16,-Y");
  asm("  OUT 0x3d,R16");
  asm("  LD R16,-Y");
  asm("  OUT 0x3e,R16");

//restore Y pointer for new current task
  asm("  LDS R30,t_r28");
  asm("  LDS R31,t_r29");
  asm("  LD R28,-Z");
  asm("  LD R29,-Z");

   }

  }

 //restore all registers
  asm("  LD R26,Y+");
  asm("  LD R15,Y+");
  asm("  LD R14,Y+");
  asm("  LD R13,Y+");
  asm("  LD R12,Y+");
  asm("  LD R11,Y+");
  asm("  LD R10,Y+");
  asm("  LD R9,Y+");
  asm("  LD R8,Y+");
  asm("  LD R7,Y+");
  asm("  LD R6,Y+");
  asm("  LD R5,Y+");
  asm("  LD R4,Y+");

  asm("OUT     0x3B,R27");
  asm("OUT     0x3F,R26");
  asm("LD      R16,Y+");
  asm("LD      R17,Y+");
  asm("LD      R18,Y+");
  asm("LD      R19,Y+");
  asm("LD      R20,Y+");
  asm("LD      R21,Y+");
  asm("LD      R22,Y+");
  asm("LD      R23,Y+");
  asm("LD      R0,Y+");
  asm("LD      R1,Y+");
  asm("LD      R2,Y+");
  asm("LD      R3,Y+");
  asm("LD      R30,Y+");
  asm("LD      R31,Y+");
  asm("LD      R24,Y+");
  asm("LD      R25,Y+");
  asm("LD      R26,Y+");
  asm("LD      R27,Y+");

//enable interrupt
  sei();
//when return restart function for current task
}

//tasks functions description
void delay(int t)
{
  do{
  }
  while(i<t); 
  i=0;
}       

void ftask1(void)
{
  for(;;){PORTB=0x01;
  //send_char('z');
  //send_char('z');
//MA_SetPortOut_IO(MA_PORTF,0xFF);
//MA_WritePort_IO(MA_PORTF,0xFF,0xFF);
//inside code for task 1
  }
}
//tasks functions description
void ftask2(void)
{
  for(;;){PORTB=0x02;
//send_char('y');
  while((b&0x08)==0x08){
  b=PINC;
  if((b&0x08)==0x00) delay(2);
  }
  while((b&0x08)==0x00){
  b=PINC;
  if((b&0x08)==0x08) delay(2);
  }
  led=~led;
  PORTB=led;
  if(aux==0) aux=1;
  else aux=0;
  schimba=1;
//inside code for task 2
  }
}
//tasks functions description
void ftask3(void)
{//if(aux==0)send_string(text1);
  //else send_string(text2);
  for(;;){PORTB=0x04;
  //send_char('x');
  if(schimba==1){ 
    if(aux==0)send_char('a');
    else send_char('b');
    schimba=0;
    //if(aux==0)send_string(text1);
    //else send_string(text2);
//inside code for task 3
  }
}
}
//tasks functions description
void ftask4(void)
{  

for(;;){
unsigned int j;
//system_watch
delay(100);
global_inc++;
//Pointer_connection
for(j=0;j<(anz-1);j++)
{
//VAR[j]=&___;...Compiler_variable declaration
}
//return values to PC!!!
for(j=0;j<(anz-1);j++)
putch(*VAR[j]);
PORTB=0x08;
       // if( UCSRA & 0x80 ){
       //*transmit=UDR; 
	   //transmit=&__;
//UDR = *pChar; }

};
} 









//functions

void R_TRIG_f(R_TRIG r_trig)
{
	akku=r_trig.CLK;
	m~=r_trig.m; 
	akku&=r_trig.m;
	r_trig.Q=akku;
	r_trig.m=r_trig.CLK;
}
  
            
void F_TRIG_f(F_TRIG f_trig)
{
	akku=f_trig.CLK;
	m~=f_trig.m;
	akku&=f_trig.m;
	f_trig.Q=akku;
	f_trig.m=f_trig.CLK;
}
               
                
void TP_f(TP tp){
	unsigned int ref;
	tp.rttimer.CLK=tp.IN;
	R_TRIG_f(tp.rttimer);
	if(tp.rttimer.Q){
			ref=global_inc;
			tp.Q=true;
			}
	else if(tp.Q){
			tp.ET=global_inc-ref;
	if(tp.ET>tp.PT)	{
			tp.Q=false;
			tp.ET=0;
			}
               	     }
		}

void TON_f(TON ton){
	ton.tp_on.IN=ton.IN;
	ton.tp_on.PT=ton.PT;
	TP(ton.tp_on);
	ton.ET=rton.tp_on.ET;
	ton.ft1.CLK=ton.IN;
	ton.ft2.CLK=ton.tp_on.Q;
	F_TRIG_f(ton.ft1);
	F_TRIG_f(ton.ft2);
	if(ton.ft1.Q&&ton.ft2.Q) ton.Q=true;
		}
                
void TOF_f(TOF tof){
	rtof.ft1.CLK=tof.IN;
	F_TRIG_f(rtof.ft1);
	tof.tp_of.IN=rtof.ft1.Q;
	TP(rtof.tp_of);
	tof.PT=tof.tp_of.PT;
	tof.ET=tof.tp_of.ET;
	tof.Q=tof.tp_of.Q;
	}

             
void ctu_f(CTU ctu){
	if(ctu.RESET){
	ctu.CV=0;
	ctu.Q=false;
		     }
	ctu.rt_up.CLK=ctu.CU;
	R_TRIG_f(ctu.rt_up);
	if(ctu.rt_up.Q) ctu.CV++;
	if(ctu.CV>CTU.PV)ctu.Q=true;
	}


              
void ctd_f(CTD ctd){
	if(ctd.LOAD){
			ctd.CV=ctd.PV;
			ctd.Q=false;
	}
	ctd.rt_down.CLK=ctd.CD;
	R_TRIG_f(ctd.rt_down);
	if(ctd.rt_down.Q) ctd.CV--;
	if(ctd.CV==0)ctd.Q=true;
	}                
        

        
void ctud_f(CTUD ctud){
	if(ctud.LOAD){
		ctud.CV=ctud.PV;
		ctud.Q=false;
		     }
else if(ctud.RESET){ctud.CV=0;
		    ctud.Q=0;
		   }
ctud.rt1.CLK=ctud.CD;
ctud.rt2.CLK=ctud.CU;
	R_TRIG_f(ctud.rt1);
	R_TRIG_f(ctud.rt2);
if(ctud.rt1.Q) ctud.CV--;
if(ctud.rt2.Q) ctud.CV++;
if(ctud.CV==0)ctud.QD=true;
if(ctud.CV==ctud.PV)ctud.QU=true;
		      }
               