




void init_hardware(void)
{
// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 62.500 kHz
// Mode: Normal top=FFh
// OC0 output: Disconnected
TCCR0=0x04;
TCNT0=0x00;
OCR0=0x00;
DDRC=0x00;
DDRB=0xFF;
// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x04;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;
TIMSK=0x04;
sei();
// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// INT2: Off
MCUCR=0x00;
MCUCSR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
//TIMSK=0x01;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00; 
 
// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: On
// USART Transmitter: On
// USART Mode: Asynchronous
// USART Baud rate: 9600 (Double Speed Mode)
//initusart();

}


void initusart(void)//initializing function
{
 unsigned char x;            // Hilfsvariable
 #ifdef UBRRL                 // USART-Schnittstelle 
  UBRRL = (TAKT / (16 * BAUD)) - 1;
  
  UCSRB |= (1 << TXEN) | (1 << RXEN);
  UCSRC |= (1 << URSEL) | (1 << UCSZ1) | (1 << UCSZ0); 
 #else                    // UART-Schnittstelle
  UBRR = (TAKT / (16 * BAUD)) - 1;
  UCR |= (1 << TXEN) | (1 << RXEN);
 #endif 
 x = UDR;                // Empfnger leeren
}


void putch (unsigned char x)  // warten und Zeichen senden
{
 #ifdef UCSRA
  loop_until_bit_is_set(UCSRA, UDRE); // warte bis Sender frei
 #else
  loop_until_bit_is_set(USR, UDRE);   // warte bis Sender frei
 #endif
 UDR = x;                             // Zeichen nach Sender    
}


unsigned char getch(void)   // warten und Zeichen abholen
{
 #ifdef UCSRA
 loop_until_bit_is_set(UCSRA, RXC);    // warte bis Zeichen da
#else 
 loop_until_bit_is_set(USR, RXC);      // warte bis Zeichen da
 #endif
 return UDR;                           // Zeichen abholen
}


// getche.c warten, Zeichen abholen und im Echo senden
unsigned char getche(void)
{
 unsigned char x;
 loop_until_bit_is_set(UCSRA, RXC);
 x = UDR;
 loop_until_bit_is_set(UCSRA, TXC);
 UDR = x;
 return x;
}


// c:\cprog\kbit.c kein Zeichen: Rckgabe 0 sonst Rckgabe Zeichen
unsigned char kbhit(void)         // Empfnger testen
{
 #ifdef UCSRA                       // USART
 if (UCSRA & (1 << RXC)) return UDR; else return 0;
#else                               // UART
 if ( USR & (1 << RXC)) return UDR; else return 0;   
 #endif
}


               


// c:\cprog3\putstring.c  String bis Endemarke Null ausgeben
void putstring(unsigned char *zeiger)  // SRAM_String ausgeben
{
 while(*zeiger != 0) putch(*zeiger++); // solange keine Endemarke NULL
}


 

               
