#include <stdlib.h>
#include <avr/io.h>

//externe Variablen - deklariert in global.c
extern unsigned char t_sph;
extern unsigned char t_spl;
extern unsigned char t_r29;
extern unsigned char t_r28;
extern unsigned char task_time;
extern unsigned char ig,jg,kg,lg,mg,ng;
extern unsigned int global_inc_g;
extern unsigned int global_inc;
extern unsigned char temp_g;
extern char lcd_sem;
extern unsigned char lcd_coada[NR_MAX_TASK];


//globale Variablen, nur in MyOS funktionen

//momentaner Taskindex
 char task_curent;

//letzter Taskindex
 char task_coada;

//erster Taskindex
 char task_varf;

//temporre Variable
unsigned int tem;

unsigned char  recieve;

task rtos[NR_MAX_TASK];


//Funktionsbeschreibung

//A. MYOS Grundfunktionen

//initialisiere RTkernel
//return - void
//Parameter: - void
void start_so(void)
{
//initialisiere Taskvektor
  task_varf=task_coada=task_curent=-1;//
//initialisiere "Ampel"-optional
  lcd_sem = -1;//initialisiere LCD-Ampel
}

//kreiere neuen Task
//Returniere - T_EROARE wenn erfolglos; T_OK falls ok
//Parameter- void(*taskf) (void) -> Pointer zu Taskfunktion (Schleife). Kann irgendwelche Funktion vom Typ void _name(void) sein
//           - unsigned char numar -> time period for the task
unsigned char creaza_task(void (*taskf)(void),unsigned char numar)
{
    unsigned int i;

//1.Anzeigen des Tasks in einer Liste
    if(task_varf==-1)//falls Liste leer
    {
      if(task_coada>=NR_MAX_TASK-1) //wenn die letzte Komponente den Taskindex berschreitet
        return T_EROARE; //returniere error
      task_coada++;//sonst - inkrementiere letzten Komponenten Index
      task_curent=task_varf=task_coada;//erster Task=momentaner Task
    }
    else   //wenn zumindest ein Task in der Liste vorhanden ist
    {
      if(task_coada>=NR_MAX_TASK-1) //wenn der letzte Task die Listenanzahl berschreitet
        return T_EROARE; //retourniere error
      task_coada++;  //sonst - inkrementiere letzten Komponenten Index
    }

    rtos[task_coada].nr_timpi=numar;//initialisiere Zeit des momentanen Task
    rtos[task_coada].activ=1;//init Status an
    for(i=0;i<OSTaskStkSize;i++)
      rtos[task_coada].adr_task[i]=(unsigned char)i;//initialisiere Task Stack
//2.initialisiere Hardware Stack mit Funktion Pointer
    i = (unsigned int) taskf;
    rtos[task_coada].adr_task[OSTaskStkSizeHard-1]=(unsigned char)i&0x0ff;//lsb
    rtos[task_coada].adr_task[OSTaskStkSizeHard-2]=(unsigned char)((i>>8)&0x0ff);//msb
//initialisiere Stack Pointer
    i = (unsigned int) rtos[task_coada].adr_task+OSTaskStkSizeHard-3;
    rtos[task_coada].adr_task[OSTaskStkSize-1]=(unsigned char)i&0xff;
    rtos[task_coada].adr_task[OSTaskStkSize-2]=(unsigned char)(i>>8)&0xff;
//initialisiere Y Pointer
    i = (unsigned int) rtos[task_coada].adr_task+62;
    rtos[task_coada].adr_task[OSTaskStkSize-3]=(unsigned char)i&0xff;
    rtos[task_coada].adr_task[OSTaskStkSize-4]=(unsigned char)(i>>8)&0xff;

    return T_OK; //retourniere OK
}

//wechsle momentanen Task von Task List
//retourniere - T_EROARE wenn Taskwechsel nicht mglich, sonst T_OK
//Parameter - void
unsigned char comuta_task(void)
{
    if(task_varf==-1)//berprfe ob Liste leer
      return T_EROARE;
   

// neuer momentaner Task nur aus aktivierten Tasks erlaubt 
    do
    {
     if(task_curent>=task_coada)//berprfe, ob momentaner Task den letzten berschreitet
       task_curent=task_varf-1;
     task_curent++;
     tem++;
    }while(!(rtos[task_curent].activ));

//initialisiere momentane Taskzeit
    task_time=rtos[task_curent].nr_timpi;
//initialisiere Hardware Stack
    tem = (unsigned int) ((rtos[task_curent].adr_task)+OSTaskStkSize)>>8;
    t_sph=(unsigned char)(tem&0x00ff);
    t_spl=(unsigned char)((rtos[task_curent].adr_task)+OSTaskStkSize)&0xff;
//initialisiere Y Pointer
    tem = (unsigned int) ((rtos[task_curent].adr_task)+OSTaskStkSize-2)>>8;
    t_r29=(unsigned char)(tem&0x00ff);
    t_r28=(unsigned char)((rtos[task_curent].adr_task)+OSTaskStkSize-2)&0xff;

    return T_OK;
}


//initialisiere t_sp und t_r Variablen aus Timer overflow ISR
//retourniere - void
//Parameter - void
void get_tsp(void)
{
//initialisiere t_sp Variablen durch Stack Pointer Wert
    tem = (unsigned int) ((rtos[task_curent].adr_task)+OSTaskStkSize)>>8;
    t_sph=(unsigned char)(tem&0x00ff);
    t_spl=(unsigned char)((rtos[task_curent].adr_task)+OSTaskStkSize)&0xff;
//initialisiere t_r Variablen mit Y Pointer Wert
    tem = (unsigned int) ((rtos[task_curent].adr_task)+OSTaskStkSize-2)>>8;
    t_r29=(unsigned char)(tem&0x00ff);
    t_r28=(unsigned char)((rtos[task_curent].adr_task)+OSTaskStkSize-2)&0xff;
}

//initialisiere Inhalt fr ersten Task- fr Multitaskingstart 
//retourniere - void
//Parameter - void
void init_task(void)
{
 //initialisiere t_sp Variable mit Stack Pointer
    task_time=rtos[task_curent].nr_timpi;
    tem = (unsigned int) ((rtos[task_curent].adr_task)+OSTaskStkSize)>>8;
    t_sph=(unsigned char)(tem&0x00ff);
    t_spl=(unsigned char)((rtos[task_curent].adr_task)+OSTaskStkSize)&0xff;
//initialisiere t_r variablen mit Y Pointer Wert
    tem = (unsigned int) ((rtos[task_curent].adr_task)+OSTaskStkSize-2)>>8;
    t_r29=(unsigned char)(tem&0x00ff);
    t_r28=(unsigned char)((rtos[task_curent].adr_task)+OSTaskStkSize-2)&0xff;
//initialisiere Y Pointer, um Registerwerte zu laden
    tem = (unsigned int) rtos[task_curent].adr_task+80;
    rtos[task_curent].adr_task[OSTaskStkSize-3]=(unsigned char)tem&0xff;
    rtos[task_curent].adr_task[OSTaskStkSize-4]=(unsigned char)(tem>>8)&0xff;
}

//initialisiere Stack Pointer Register und Y pointer mit Werten des ersten Tasks(=um multitasking zu starten)
//Retourniere - void
//Parameter - void
//Beachte -Bei Aufruf dieser Funktion kann innerhalb dieser der Stack Pointer und Hardwarestack beim Retournieren abgendert werden beim Autostart des ersten Tasks!
void PopSP(void)
{
  cli();//deaktiviere alle Interrupts
  asm("  LDS R29,t_sph");//lade Stack Pointer Adresse in Y Pointer Register
  asm("  LDS R28,t_spl");
  asm("  LD R16,-Y");//lade Stack Pointer fr ersten Task
  asm("  OUT 0x3d,R16");
  asm("  LD R16,-Y");
  asm("  OUT 0x3e,R16");

//setze Y Pointer fr ersten Task
  asm("  LDS R30,t_r28");
 // asm("  LDS R31,t_0r29");
  asm("  LD R28,-Z");
  asm("  LD R29,-Z");

  b_start_so=1;
 sei();
//beim Return starte automatisch erste Taskfunktion
}

//speichere globale Variablen in Task Stack
//retourniere - void
//Parameter - void
//Beachte : Falls mehr globale Variablen erforderlich sind, definiere sie hier
void push_var(void)
{

  rtos[task_curent].adr_task[OSTaskStkSize-5]=ig;
  rtos[task_curent].adr_task[OSTaskStkSize-6]=jg;
  rtos[task_curent].adr_task[OSTaskStkSize-7]=kg;
  rtos[task_curent].adr_task[OSTaskStkSize-8]=lg;
  rtos[task_curent].adr_task[OSTaskStkSize-9]=mg;
  rtos[task_curent].adr_task[OSTaskStkSize-10]=ng;

//Hier sind diese anderen globalen Variablen hinzuzufgen
  rtos[task_curent].adr_task[OSTaskStkSize-11]=temp_g;
 // rtos[task_curent].adr_task[OSTaskStkSize-12]=init_t;
}

//load global variable from task stack
//return - void
//parameters - void
//NOTE : if are needed more global variables load here
void pop_var(void)
{
//unsigned char ig,jg,kg,lg,mg,ng;
  ig=rtos[task_curent].adr_task[OSTaskStkSize-5];
  jg=rtos[task_curent].adr_task[OSTaskStkSize-6];
  kg=rtos[task_curent].adr_task[OSTaskStkSize-7];
  lg=rtos[task_curent].adr_task[OSTaskStkSize-8];
  mg=rtos[task_curent].adr_task[OSTaskStkSize-9];
  ng=rtos[task_curent].adr_task[OSTaskStkSize-10];

  //add here another global variable
  temp_g=rtos[task_curent].adr_task[OSTaskStkSize-11];
 // init_t=rtos[task_curent].adr_task[OSTaskStkSize-12];
}

//SEMAPHORE FUNCTIONS

//context switching when semaphore event occure
//return - void
//parameters - void
//NOTE : this function is similar with timer ISR but this function is manualy called
//       when return restart function for current task
void comuta(void)
{
//disable all interrupts
   cli();

//save registers using Y pointer
  asm("ST      -Y,R27");
  asm("ST      -Y,R26");
  asm("ST      -Y,R25");
  asm("ST      -Y,R24");
  asm("ST      -Y,R31");
  asm("ST      -Y,R30");
  asm("ST      -Y,R3");
  asm("ST      -Y,R2");
  asm("ST      -Y,R1");
  asm("ST      -Y,R0");
  asm("ST      -Y,R23");
  asm("ST      -Y,R22");
  asm("ST      -Y,R21");
  asm("ST      -Y,R20");
  asm("ST      -Y,R19");
  asm("ST      -Y,R18");
  asm("ST      -Y,R17");
  asm("ST      -Y,R16");
  asm("IN      R26,0x3F");
  asm("IN      R27,0x3B");
  asm("  ST -Y, R4");
  asm("  ST -Y, R5");
  asm("  ST -Y, R6");
  asm("  ST -Y, R7");
  asm("  ST -Y, R8");
  asm("  ST -Y, R9");
  asm("  ST -Y, R10");
  asm("  ST -Y, R11");
  asm("  ST -Y, R12");
  asm("  ST -Y, R13");
  asm("  ST -Y, R14");
  asm("  ST -Y, R15");
  asm("  ST -Y, R26");

//init global_inc -
    global_inc=0;
    t_sph=0;
    t_spl=0;
    t_r29=0;
    t_r28=0;
    get_tsp();//init t_sp and t_r variables

//save pointer Y adress - using Z pointer already saved
    asm("  LDS R30,t_r28");//R26 <- t_r28
    asm("  LDS R31,t_r29");//R27 <- t_r29
    asm("  ST -Z, R28");//save Y adress
    asm("  ST -Z, R29");

//save stack pointer
    asm("  LDS R30,t_spl");//save stack pointer using Y pointer already saved
    asm("  LDS R31,t_sph");
    asm("  IN R16,0x3d");//save SPH
    asm("  ST -Z,R16");
    asm("  IN R16,0x3e");//save SPL
    asm("  ST -Z,R16");

    push_var();//save global variables
    comuta_task();//task switching
    pop_var();//restore global variables for new current task

//restore stack pointer register for new curent task
  asm("  LDS R28,t_spl");
  asm("  LDS R29,t_sph");
  asm("  LD R16,-Y");
  asm("  OUT 0x3d,R16");
  asm("  LD R16,-Y");
  asm("  OUT 0x3e,R16");

//restore Y pointer using Z pointer
  asm("  LDS R30,t_r28");
  asm("  LDS R31,t_r29");
  asm("  LD R28,-Z");
  asm("  LD R29,-Z");

//restore all registers
  asm("  LD R26,Y+");
  asm("  LD R15,Y+");
  asm("  LD R14,Y+");
  asm("  LD R13,Y+");
  asm("  LD R12,Y+");
  asm("  LD R11,Y+");
  asm("  LD R10,Y+");
  asm("  LD R9,Y+");
  asm("  LD R8,Y+");
  asm("  LD R7,Y+");
  asm("  LD R6,Y+");
  asm("  LD R5,Y+");
  asm("  LD R4,Y+");

  asm("OUT     0x3B,R27");
  asm("OUT     0x3F,R26");
  asm("LD      R16,Y+");
  asm("LD      R17,Y+");
  asm("LD      R18,Y+");
  asm("LD      R19,Y+");
  asm("LD      R20,Y+");
  asm("LD      R21,Y+");
  asm("LD      R22,Y+");
  asm("LD      R23,Y+");
asm("LD      R0,Y+");
asm("LD      R1,Y+");
asm("LD      R2,Y+");
asm("LD      R3,Y+");
asm("LD      R30,Y+");
asm("LD      R31,Y+");
asm("LD      R24,Y+");
asm("LD      R25,Y+");
asm("LD      R26,Y+");
asm("LD      R27,Y+");

//enable interrupt
  sei();
//when return restart function for current task
}

//request acces to LCD
//return - void
//parameters - void
void lcd_req(void)
{
//test ressource status
  if(lcd_sem>=0)//semaphore busy?
  {
    lcd_coada[lcd_sem]=task_curent;//add curent task in wainting queue for LCD semaphore
    rtos[task_curent].activ = 0;//inactive task
  }
  lcd_sem++;//increment status seamphore
  if(lcd_sem>=NR_MAX_TASK)//test maxim size
    lcd_sem=0;
}

//release lcd resource
//return - void
//parameters - void
void lcd_release(void)
{
 if(lcd_sem>0)//check semaphore status
 {
  rtos[lcd_coada[0]].activ = 1; //reactivate first task in waiting queue for semaphore - this is the first current task
//delete first task from waiting queue
  for(ig=0;ig<lcd_sem-1;ig++)
   lcd_coada[ig]=lcd_coada[ig+1];
  lcd_coada[lcd_sem-1]=0;
 }
 lcd_sem--;//decrement semaphore
 if(lcd_sem<-1)//test minim
  lcd_sem=-1;
}



//3. OTHERS FUNCTIONS

//delay (here ms)
////return - void
//parameters - void
void delay_1_ms(unsigned int time)
{
 unsigned int in;

  in  = global_inc_g;
  for(;;)
  {
   if(in>global_inc_g)
   {
    if(((0xffff-in)+global_inc_g)>=(time*21))
     break;
   }
   else
   {
    if((global_inc_g-in)>=(time*21))
     break;
   }
  }
}



